//----------------------------------------------------------------

#define PriorityKey  "Software\\NetWorkDLS\\448Delta\\Priority"
#define EncDlgKey    "Software\\NetWorkDLS\\448Delta\\EncryptDialog"
#define DecDlgKey    "Software\\NetWorkDLS\\448Delta\\DecryptDialog"
#define StatDlgKey   "Software\\NetWorkDLS\\448Delta\\StatusDialog"
#define PathKey      "Software\\NetWorkDLS\\448Delta\\Path"

#define TitleCaption "448Delta Encryption"  // Application Title
#define MutexName    "448Delta_Encryption"  // Application Mutex Name
#define FileVersion  "1.0.2.9"              // Application Version

#define FINISHEDWE   "Finished with errors!"
#define WRONGPWCD    "Wrong Password, Can't Decrypt!"

#define CONTACT_INFO "If you have any further problems. Please contact Tech@NetWorkDLS.com with this error message."
#define FlagLenght   sizeof(DWORD)
#define Reserved     ((1 * 448) + 64)
#define ENCFlag      ((2 * 448) + 64)
#define PACFlag      ((3 * 448) + 64)
#define ENCCompress  ((4 * 448) + 64)
#define PACCompress  ((5 * 448) + 64)

#define MegaByte     1048576  // One Megabyte (1,048,576 Bytes)

#define MaxFileSize  250 * MegaByte
#define MaxFiles     10240
#define BufferSize   5120

//---------------------(HWND & INSTANCE Definitions)
HINSTANCE MainInstance    = NULL;     // WinMain (Application) Instance

HWND StatusBar_hWnd       = NULL;

HWND EncryptDialog_hWnd   = NULL;
HWND DecryptDialog_hWnd   = NULL;
HWND StatusDialog_hWnd    = NULL;

//---------------------(Function Prototypes)
void Error(char *);
BOOL SetPriority(void);

DWORD WINAPI PasswordDialog_Thread(LPVOID);
HANDLE PasswordDialog_Thread_Handle;
DWORD PasswordDialog_Thread_ID;

DWORD WINAPI StartProcess_Thread(LPVOID);
HANDLE StartProcess_Thread_Handle;
DWORD StartProcess_Thread_ID;

BOOL StartProcess(void);

//---------------------(Structure Prototypes)
struct _448ProcessInfo{
    BOOL CompressOption;
    BOOL CreateSelfOption;
    BOOL DeleteSourceOption;
    BOOL DestroyTempOption;
    BOOL UsePriorityOption;

    char TempFile1[257];
    char TempFile2[257];

    HWND StatusText_hWnd;
    HWND OKCancelButton_hWnd;

    BOOL CancelFlag;
    BOOL ErrorFlag;
    BOOL CompleteFlag;
    BOOL ReadyToProcess;
    BOOL ProcededWithOverwrite;

    double StatusValue;
    double LastValue;

    char AfterText[1024];
    char StatusText[1024];
    char GlobalTarget[256];
    char GlobalSource[256];
    char *Password;

    int FileFlagResult;
    int PreCheckResult;

}; _448ProcessInfo PI;

//---------------------(Dialog Prototypes)
BOOL CALLBACK EncryptDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK DecryptDialog(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK StatusDialog(HWND, UINT, WPARAM, LPARAM);

//----------------------------------------------------------------

